﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ErrorbarDirection
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
    }

    public class CustomCrossHair : ChartBehavior
    {
        bool IsActivated;
        Line line1;
        Line line2;
        protected override void OnMouseMove(MouseEventArgs e)
        {
           
            if (Mouse.LeftButton != MouseButtonState.Pressed)
                IsActivated = true;

            var point = e.GetPosition(this.AdorningCanvas);
            if (this.ChartArea != null && IsActivated )
            {
                if (line1.Visibility == Visibility.Collapsed)
                    line1.Visibility = Visibility.Visible;
                if (line2.Visibility == Visibility.Collapsed)
                    line2.Visibility = Visibility.Visible;
                line1.X1 = point.X - this.ChartArea.SeriesClipRect.Width * 0.03;
                line1.X2 = point.X + this.ChartArea.SeriesClipRect.Width * 0.03;
                line1.Y1 = point.Y;
                line1.Y2 = point.Y;

                line2.X1 = point.X;
                line2.X2 = point.X;
                line2.Y1 = point.Y - this.ChartArea.SeriesClipRect.Height * 0.04;
                line2.Y2 = point.Y + this.ChartArea.SeriesClipRect.Height * 0.04;

                line2.Stroke = new SolidColorBrush(Colors.Red);
                line1.Stroke = new SolidColorBrush(Colors.Red);
            }
        }

        protected override void AttachElements()
        {
            line1 = new Line();
            line2 = new Line();
            base.AttachElements();
            this.AdorningCanvas.Children.Add(line1);
            this.AdorningCanvas.Children.Add(line2);
        }

        protected override void OnMouseLeave(MouseEventArgs e)
        {
            if (IsActivated)
            {
                IsActivated = false;
                line1.Visibility = Visibility.Collapsed;
                line2.Visibility = Visibility.Collapsed;
            }         
        }

        protected override void DetachElements()
        {
            base.DetachElements();
            this.AdorningCanvas.Children.Clear();
        }

    }
}
